package test.de.abraxas;

import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Reader;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;

import org.glassfish.embeddable.Deployer;
import org.glassfish.embeddable.GlassFish;
import org.glassfish.embeddable.GlassFishException;
import org.glassfish.embeddable.GlassFishProperties;
import org.glassfish.embeddable.GlassFishRuntime;
import org.glassfish.embeddable.archive.ScatteredArchive;

public class EGFTest {

	/**
	 * @param args
	 * @throws GlassFishException 
	 * @throws IOException 
	 */
	public static void main(String[] args) throws Exception {
		GlassFishProperties props = new GlassFishProperties(); 
		props.setPort("http-listener", 8080);
		GlassFishRuntime gfruntime =GlassFishRuntime.bootstrap();
		GlassFish gf =  gfruntime.newGlassFish(props);
		gf.start();
		Deployer deployer = gf.getDeployer();
		ScatteredArchive archive = new ScatteredArchive("jsf", ScatteredArchive.Type.WAR,new File("WebContent/"));
		
		deployer.deploy(archive.toURI(),"--name", "jsf", "--contextroot=app1");
		
		String urlApp1 = "http://localhost:8080/app1/faces/index.xhtml";
		String urlApp2 = "http://localhost:8080/app2/faces/index.xhtml";

		// comment this out to get both apps working  
		printPage(urlApp1);
		try {
			System.out.println(urlApp1+" will stop working in 15 seconds");
			Thread.sleep(15000);			
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		deployer.deploy(archive.toURI(),"--name", "jsf2", "--contextroot=app2");
		// app1 is damaged
		printPage(urlApp1);
		//app2 still working
		printPage(urlApp2);
	}

	private static void printPage(String urlStr) throws Exception{
			URL url = new URL(urlStr);
			URLConnection conn = url.openConnection();
			String line;
			BufferedReader reader =new BufferedReader(new InputStreamReader(conn.getInputStream())); 
			 while ((line = reader.readLine()) != null) {
			    System.out.println(line);
			 }
			 reader.close();
	}
}
